from django.db import models


class Person (models.Model):
    name = models.CharField('name', max_length=200)

    def __unicode__(self):
        return unicode(self.name)


class Exchange (models.Model):
    name = models.CharField(max_length=200)
    symbol = models.CharField(max_length=10)

    def __unicode__(self):
        return unicode(self.name)


class Company (models.Model):
    name = models.CharField(max_length=200)

    def __unicode__(self):
        return unicode(self.name)


class Ticker (models.Model):
    symbol = models.CharField(max_length=10)
    company = models.ForeignKey(Company)
    exchange = models.ForeignKey(Exchange)

    def __unicode__(self):
        return u'{0.exchange.symbol}:{0.symbol}'.format(self)


class Transaction (models.Model):
    person = models.ForeignKey(Person)
    date = models.DateTimeField()
    ticker = models.ForeignKey(Ticker)    
    shares = models.IntegerField('number of shares')
    value = models.DecimalField(
        'value in US dollars', max_digits=20, decimal_places=2)
    # If you want to track values in several currencies, check out the
    # python-money package: http://code.google.com/p/python-money/

    def __unicode__(self):
        return (u'{0.person} traded {0.shares} shares (${0.value}) '
                'of {0.ticker} on {0.date}').format(self)
